"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.boolExpToSQL = exports.applyBoolExpToLink = exports.replaceSymbol = exports.api = void 0;
const client_1 = require("@deep-foundation/hasura/client");
const api_1 = require("@deep-foundation/hasura/api");
const client_2 = require("./client");
exports.api = new api_1.HasuraApi({
    path: process.env.DEEPLINKS_HASURA_PATH,
    ssl: !!+process.env.DEEPLINKS_HASURA_SSL,
    secret: process.env.DEEPLINKS_HASURA_SECRET,
});
const client = (0, client_1.generateApolloClient)({
    path: `${process.env.DEEPLINKS_HASURA_PATH}/v1/graphql`,
    ssl: !!+process.env.DEEPLINKS_HASURA_SSL,
    secret: process.env.DEEPLINKS_HASURA_SECRET,
});
const deep = new client_2.DeepClient({
    apolloClient: client,
});
exports.replaceSymbol = '777777777777';
const applyBoolExpToLink = (sql, linkId) => {
    return sql.replace(exports.replaceSymbol, `${linkId}`);
};
exports.applyBoolExpToLink = applyBoolExpToLink;
const boolExpToSQL = (boolExpId, boolExpValue) => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b, _c;
    try {
        const gql = JSON.stringify(boolExpValue).replace(/"([^"]+)":/g, '$1:');
        const explained = yield exports.api.explain(`{ links(where: { _and: [{ id: { _eq: ${exports.replaceSymbol} } }, ${gql}] }, limit: 1) { id } }`);
        const sql = (_b = (_a = explained === null || explained === void 0 ? void 0 : explained.data) === null || _a === void 0 ? void 0 : _a[0]) === null || _b === void 0 ? void 0 : _b.sql;
        if (sql) {
            const convertedSql = `SELECT json_array_length("root") as "root" FROM (${sql}) as "root"`;
            const boolExp = yield deep.select({ link_id: { _eq: boolExpId } }, { table: 'bool_exp', returning: 'id link_id' });
            const boolExpLink = (_c = boolExp === null || boolExp === void 0 ? void 0 : boolExp.data) === null || _c === void 0 ? void 0 : _c[0];
            if (boolExpLink) {
                const mutateResult = yield deep.update(boolExpLink.id, {
                    value: convertedSql,
                }, { table: 'bool_exp' });
            }
            else {
                const mutateResult = yield deep.insert({
                    link_id: boolExpId,
                    value: convertedSql,
                }, { table: 'bool_exp' });
            }
        }
    }
    catch (error) {
        console.log(error);
    }
});
exports.boolExpToSQL = boolExpToSQL;
//# sourceMappingURL=bool_exp.js.map